(ns clojsa.saclient
  (:require [clojure.string :as string]
            [http.async.client :as http]))


(def url "https://forums.somethingawful.com/")

(defn thread-url
  ([id]
   (thread-url id 1))
  ([id page]
   (let [base-url (str url "showthread.php")
         query {:threadid id
                :pagenumber page}]
     {:href base-url :params query})))

(defn login-response [username password session]
  (with-open [client (http/create-client)]
    (let [login-url (str url "account.php")
          params {:action "login"
                  :username username
                  :password password}
          resp (http/POST client login-url :body params)
          status (http/status resp)
          headers (http/headers resp)]
      (-> resp
          http/await
          http/cookies))))

(defn thread-response [session url]
  (with-open [client (http/create-client)]
    (let [{:keys [href params]} url
          req-cookies (:cookies session)
          resp (http/GET client href :query params :cookies req-cookies)
          status (http/status resp)
          headers (http/headers resp)]
      (-> resp
          http/await
          http/string))))
